<Query Kind="Statements" />

var note = new Note (20, 100) { Channel = 10 };

var note2 = note.WithDuration (200);
note2.Dump ("Non-destructive mutation");
note.Dump ("Original");

public class Note
{
	public int Pitch { get; }
	public int Duration { get; }
	public int? Volume { get; init; }
	public int? Channel { get; init; }

	public Note (int pitch, int duration)
	{
		Pitch = pitch;
		Duration = duration;
	}

	public Note WithPitch (int pitch) =>
		new Note (pitch, Duration) { Volume = Volume, Channel = Channel };

	public Note WithDuration (int duration) =>
		new Note (Pitch, duration) { Volume = Volume, Channel = Channel };

	public Note WithVolume (int? volume) =>
		new Note (Pitch, Duration) { Volume = volume, Channel = Channel };

	public Note WithChannel (int? channel) =>
		new Note (Pitch, Duration) { Volume = Volume, Channel = channel };
}
