<Query Kind="Statements" />

var point = new Point (1, 1);
point.DistanceFromOrigin.Dump();

var point2 = point with { Y = 10 };
point2.DistanceFromOrigin.Dump();    // Works

record Point
{
	double _x, _y;
	public double X { get => _x; init { _x = value; _distance = null; } }
	public double Y { get => _y; init { _y = value; _distance = null; } }

	double? _distance;
	public double DistanceFromOrigin
	{
		get
		{
			if (_distance == null)
				_distance = Math.Sqrt (X * X + Y * Y);

			return _distance.Value;
		}
	}

	public Point (double x, double y) 
	{
		X = x;
		Y = y;
	}
}
