<Query Kind="Statements" />

var point = new Point (1, 1);
point.DistanceFromOrigin.Dump();

var point2 = point with { Y = 10 };
point2.DistanceFromOrigin.Dump(); 

record Point
{
	public double X { get; init; }
	public double Y { get; init; }

	double? _distance;
	public double DistanceFromOrigin
	{
		get
		{
			if (_distance == null)
				_distance = Math.Sqrt (X * X + Y * Y);

			return _distance.Value;
		}
	}

	public Point (double x, double y)
	{
		X = x;
		Y = y;
	}
}
