<Query Kind="Statements" />

var p1 = new Point (1, 2);
var p2 = new Point (1, 2);

p1.Equals (p2).Dump();
(p1 == p2).Dump();

#region If Point were a class...
class PointClass : IEquatable<PointClass>
{
	public double X { get; init; }
	public double Y { get; init; }

	public override bool Equals (object obj) =>
		obj is Point other && Equals (other);

	public bool Equals (PointClass other) =>
		!ReferenceEquals (other, null) &&
		X == other.X && 
		Y == other.Y;

	public override int GetHashCode() => (X, Y).GetHashCode();

	public static bool operator == (PointClass p1, PointClass p2) =>
		p1?.Equals (p2) ?? false;

	public static bool operator != (PointClass p1, PointClass p2) =>
		!(p1 == p2);
}
#endregion

record Point (double X, double Y)
{
	public virtual bool Equals (Point other) =>
		!ReferenceEquals (other, null) &&
		X == other.X && 
		Y == other.Y;
		
	public override int GetHashCode() => (X, Y).GetHashCode();
}

